% show non-linear function in the gradient algorithm


close all

log10e=log10(exp(1));

%case 1 %% Gaussian
PHI_G = @(x,sig) qfunc(-x/sig);
PHI_G_prim = @(x,sig) 1/sig* exp( -(x/sig).^2/2 )/sqrt(2*pi);
PHI_G_bis = @(x,sig) -x/(sig^3) .*exp(-(x/sig).^2/2)/sqrt(2*pi);
psi_G     = @(x,sig) PHI_G_prim(x,sig) ./ PHI_G(x,sig);
% case 2 %% Logistic
PHI_L = @(x,sig)  1./(1+10.^(-x./sig));
PHI_L_prim = @(x,sig) 1/(sig*log10e) * 10.^(-x./sig)./(1+10.^(-x./sig)).^2;
PHI_L_bis = @(x,sig) 1/(sig*log10e)^2 * 10.^(-x./sig).*(10.^(-x./sig)-1)./(1+10.^(-x./sig)).^3;
psi_L     = @(x,sig) PHI_L_prim(x,sig) ./ PHI_L(x,sig);

figure(1)
sig=2;
sigL = sig*sqrt(pi/8)*log(10);
tt=linspace(-3,3,1000)'*sig;
ii=(1:100:length(tt)-100)';

% Gauss
%% PHI(x)
h1=plot(tt, PHI_G(tt,sig),'-m' );hold('on')
plot(tt(ii),PHI_G(tt(ii),sig),'xm')
%% XI(x) 
h2=plot(tt, PHI_G_prim(tt,sig)./ (PHI_G( tt,sig).*PHI_G( -tt,sig)) ,'--m');
plot(tt(ii), PHI_G_prim(tt(ii),sig)./ (PHI_G( tt(ii),sig).*PHI_G( -tt(ii),sig)) ,'xm');
%plot(tt, abs(tt)/sig^2,'--r' )
%% r(x)
h3=plot(tt, -PHI_G_bis(tt,sig)./PHI_G( tt,sig)+(psi_G(tt,sig)).^2   ,'-.m' );
plot(tt(ii), -PHI_G_bis(tt(ii),sig)./PHI_G( tt(ii),sig)+(psi_G(tt(ii),sig)).^2   ,'xm' );
%plot(tt, -PHI_G_bis(-tt,sig)./PHI_G( -tt,sig)+(psi_G(-tt,sig)).^2   ,'-.m' )

%% Logistic
plot(tt, PHI_L( tt, sigL ),'-g' )
plot(tt, 1/(sigL*log10e)*ones(size(tt)), 'g--')
plot(tt, -PHI_L_bis(tt,sigL)./PHI_L( tt,sigL) +(psi_L(tt,sigL) ).^2   ,'-.g' )
% markers
ii2=ii+50;
plot(tt(ii2), PHI_L( tt(ii2), sigL ),'og' )
plot(tt(ii2), 1/(sigL*log10e)*ones(size(tt(ii2))), 'og')
plot(tt(ii2), -PHI_L_bis(tt(ii2),sigL)./PHI_L( tt(ii2),sigL) +(psi_L(tt(ii2),sigL) ).^2   ,'og' )
%plot(tt, PHI_L_prim(tt,sigL)/(sigL*log10e)  ,'gx' )

legend([h1,h2, h3],{'Phi','xi','psi.pr'},'FontSize',20)
grid on
axis([-3*sig 3*sig 0 1.4])
set(gca,'FontSize',12)
% figure(2)
% zz=linspace(1,2,100)';
% for kz=1:length(zz)
% sigL = sig*zz( kz );
% vv(kz,1)=norm(PHI_G(tt,sig)-PHI_L(tt,sigL))^2;
% end
% plot(zz, vv)
%  
% % plot(tt, -PHI_bis(tt,sig)./PHI(tt,sig)+(PHI_prim(tt,sig)./PHI(tt,sig)).^2, C_line),hold('on')
% 
% % probabiblities for W-L-D
% % plot(tt, [PHI(tt).^2 PHI(-tt).^2 2*(PHI(tt).*PHI(-tt)) ] , C_line ),hold('on')
% 
% figure(1),
% ttt=linspace(min(tt),0,10)';
% plot(ttt,[abs(ttt)  abs(ttt)+1./abs(ttt)],'r--')
% grid on

fname='gradient';
print('-depsc','-r400',['./',fname,'.eps'])

% figure(2), grid on
% fname='hessian';
% print('-depsc','-r400',['./',fname,'.eps'])
%
% tt=linspace(-10,10,1000)';
% figure(3)
% xi_N= exp(-tt.^2/2)/sqrt(2*pi) ./ ( qfunc(-tt).*qfunc(tt) );
% psi_L= 1./(1+exp(tt));
% plot( tt, [xi_N abs(tt)])
